%clear, clc
x_max = 2;

M = 41;
I1 = zeros(M); I2 = I1;
I1((M+1)/2,(M+1)/2) = 1;
I2((M+1)/2 + 1.6*(M-1)/4,(M+1)/2 + 1.6*(M-1)/4) = 1;
I2((M+1)/2 + 0.4*(M-1)/4,(M+1)/2 - 0.4* (M-1)/4) = 1;

rho0 = double(I1);
rho1 = double(I2);

dx = 2*x_max/(M-1);
mu = dx/4; 
tic
[mx,my,u] = pri_dual2(rho0,rho1,mu,dx);
toc
%% plot
close all

figure(3)
plotu(rho0,x_max,1); hold on
plot(0,0,'r*')
hold on;
plotu(rho1,x_max,1);
axis square
%% New vector field
newmx=zeros(M+1);
newmy=zeros(M+1);
for i=2:M
    for j=2:M
        newmx(i,j)=0.5*(mx(i,j)+mx(i+1,j));
        newmy(i,j)=0.5*(my(i,j)+my(i,j+1));
    end
end
quiver(-x_max:dx:x_max, -x_max:dx:x_max, newmy(1:M, 1:M) , ...
    newmx(1:M, 1:M));
% 
truth = 0.4*sqrt(2);
relerr = abs(sum(sum(sqrt(newmx.^2+newmy.^2)))-truth)/truth

figure(4)
surf(1:M,1:M,rho0)
figure(5)
surf(1:M,1:M,rho1)
figure(6)
surf(1:M,1:M,u)